<?php

namespace Lc\ShopBundle\Price\Services;

use Doctrine\Common\Collections\Collection;
use Lc\ShopBundle\Context\OrderProductInterface;
use Lc\ShopBundle\Context\OrderShopInterface;
use Lc\ShopBundle\Context\ProductFamilyInterface;
use Lc\ShopBundle\Context\ProductInterface;
use Lc\ShopBundle\Context\ProductPropertyInterface;
use Lc\ShopBundle\Context\ReductionCatalogInterface;

class OrderProductPriceUtils
{
        use PriceUtilsTrait ;

        protected $productPriceUtils ;

        public function __construct(ProductPriceUtils $productPriceUtils)
        {
                $this->productPriceUtils = $productPriceUtils ;
        }

        public function getPrice(OrderProductInterface $orderProduct)
        {
                return $orderProduct->getPrice();
        }

        public function getPriceWithTax(OrderProductInterface $orderProduct)
        {
                return $this->applyTax(
                        $this->getPrice($orderProduct),
                        $orderProduct->getTaxRate()->getValue()
                );
        }

        public function getPriceWithTaxAndReduction(OrderProductInterface $orderProduct)
        {

        }


        public function getPriceByRefUnit(OrderProductInterface $orderProduct)
        {
                return ($this->getPrice($orderProduct) * $orderProduct->getUnit()->getCoefficient()) / $orderProduct->getQuantityProduct();
        }

        public function getPriceByRefUnitWithTax(OrderProductInterface $orderProduct)
        {
                return $this->applyTax(
                        $this->getPriceByRefUnit($orderProduct),
                        $orderProduct->getTaxRate()->getValue()
                );

        }

        public function getPriceByRefUnitWithTaxAndReduction(OrderProductInterface $orderProduct)
        {

        }

        public function getTotal(OrderProductInterface $orderProduct)
        {
                return $orderProduct->getQuantityOrder() * $this->getPrice($orderProduct);
        }

        public function getTotalWithReductionCatalog(OrderProductInterface $orderProduct)
        {

        }

        public function getTotalWithReductionCart(OrderProductInterface $orderProduct)
        {

        }

        public function getTotalWithReductions(OrderProductInterface $orderProduct)
        {

        }

        public function getTotalWithTax(OrderProductInterface $orderProduct)
        {
                return $this->applyTax(
                        $this->getTotal($orderProduct),
                        $orderProduct->getTaxRateInherited()->getValue()
                );
        }

        public function getTotalWithTaxAndReductionCatalog(OrderProductInterface $orderProduct)
        {

        }

        public function getTotalWithTaxAndReductionCart(OrderProductInterface $orderProduct)
        {

        }

        public function getTotalWithTaxAndReductions(OrderProductInterface $orderProduct)
        {

        }
}

